//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.ObservableCommandTest
{
    
    
    /// <summary>
    /// A class that exposes the IObservableCommandTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ObservableCommandTestProvider : IFeatureProvider
    {
        
        private IObservableCommandTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(ObservableCommandTestProvider).Assembly, "ObservableCommandTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public ObservableCommandTestProvider(IObservableCommandTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        private System.Exception ConvertCountExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "n"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ObservableCommandTest/v1/Command/Count/Parameter/N", ex.Message);
                }
                if ((ex.ParamName == "delay"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ObservableCommandTest/v1/Command/Count/Parameter/Delay", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        private System.Exception ConvertEchoValueAfterDelayExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "value"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ObservableCommandTest/v1/Command/EchoValueAfterDelay/Parame" +
                            "ter/Value", ex.Message);
                }
                if ((ex.ParamName == "delay"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ObservableCommandTest/v1/Command/EchoValueAfterDelay/Parame" +
                            "ter/Delay", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterCommandWithIntermediates<CountRequestDto, long, CountIntermediateDto, long, CountResponseDto>("Count", Count, ConvertCountIntermediate, ConvertCountResponse, ConvertCountExceptions);
            registration.RegisterObservableCommand<EchoValueAfterDelayRequestDto, long, EchoValueAfterDelayResponseDto>("EchoValueAfterDelay", EchoValueAfterDelay, ConvertEchoValueAfterDelayResponse, ConvertEchoValueAfterDelayExceptions);
        }
        
        private CountIntermediateDto ConvertCountIntermediate(long intermediate)
        {
            return new CountIntermediateDto(intermediate, _server);
        }
        
        private CountResponseDto ConvertCountResponse(long result)
        {
            return new CountResponseDto(result, _server);
        }
        
        /// <summary>
        /// Executes the Count command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IIntermediateObservableCommand<long, long> Count(CountRequestDto request)
        {
            request.Validate();
            return _implementation.Count(request.N.TryExtract(_server, "org.silastandard/test/ObservableCommandTest/v1/Command/Count/Parameter/N"), request.Delay.TryExtract(_server, "org.silastandard/test/ObservableCommandTest/v1/Command/Count/Parameter/Delay"));
        }
        
        private EchoValueAfterDelayResponseDto ConvertEchoValueAfterDelayResponse(long result)
        {
            return new EchoValueAfterDelayResponseDto(result, _server);
        }
        
        /// <summary>
        /// Executes the Echo Value After Delay command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand<long> EchoValueAfterDelay(EchoValueAfterDelayRequestDto request)
        {
            request.Validate();
            return _implementation.EchoValueAfterDelay(request.Value.TryExtract(_server, "org.silastandard/test/ObservableCommandTest/v1/Command/EchoValueAfterDelay/Parame" +
                        "ter/Value"), request.Delay.TryExtract(_server, "org.silastandard/test/ObservableCommandTest/v1/Command/EchoValueAfterDelay/Parame" +
                        "ter/Delay"));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/ObservableCommandTest/v1/Command/Count"))
            {
                return typeof(IObservableCommandTest).GetMethod("Count");
            }
            if ((commandIdentifier == "org.silastandard/test/ObservableCommandTest/v1/Command/EchoValueAfterDelay"))
            {
                return typeof(IObservableCommandTest).GetMethod("EchoValueAfterDelay");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}

